//----------------------------------------------------------------------//
//HotQ																	//
//	Nbv{[h													//
//																		//
//----------------------------------------------------------------------//
#ifndef ClipListH
#define ClipListH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <System.Actions.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Menus.hpp>
#include <Vcl.ActnList.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.Buttons.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.StdActns.hpp>
#include <Vcl.ToolWin.hpp>
#include <Vcl.Clipbrd.hpp>

//---------------------------------------------------------------------------
#define MAX_TEXTDATABTN		8	//^I{^̐

//---------------------------------------------------------------------------
//f[^
//---------------------------------------------------------------------------
class HistoryRec {
public:
	UnicodeString Text;		//eLXge
	UnicodeString ItemStr;	//\
	int LineCount;			//s
	TDateTime  CreTime;		//쐬

	HistoryRec(UnicodeString s = EmptyStr);
};

//---------------------------------------------------------------------------
//Xg
//---------------------------------------------------------------------------
class THistoryList : public TList {
private:
	HistoryRec * __fastcall Get(int Index);
	void __fastcall Put(int Index, HistoryRec *Item);

public:
	__fastcall THistoryList();
	__fastcall ~THistoryList();

	__property HistoryRec * Items[int Index] = {read=Get, write=Put};

	void __fastcall SaveToFile(UnicodeString fname);
	void __fastcall LoadFromFile(UnicodeString fname);
};


//---------------------------------------------------------------------------
class TClipBdList : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TAction *AllDelAction;
	TAction *CopyClipAction;
	TAction *DelItemAction;
	TAction *EditTextDataAction;
	TAction *EditTextItemAction;
	TAction *ExLineAction;
	TAction *InsFromClipAction;
	TAction *ListExceptAction;
	TAction *ListExtractAction;
	TAction *ListReleaseAction;
	TAction *LoadHistAction;
	TAction *PasteAction;
	TAction *RegFromClipAction;
	TAction *RegToTextAction;
	TAction *ReloadTextDataAction;
	TAction *SaveHistAction;
	TAction *SortLengthAction;
	TAction *SortLineCntAction;
	TAction *SortTextAction;
	TAction *SortTimeAction;
	TAction *StopAction;
	TActionList *ActionList1;
	TBitBtn *ListExcBtn;
	TBitBtn *ListExtBtn;
	TBitBtn *ListRelBtn;
	TButton *EditCanBtn;
	TButton *EditOkBtn;
	TComboBox *FindComboBox;
	TEdit *ItemLabelEdit;
	TEditCopy *StdEditCopyAction;
	TEditCut *StdEditCutAction;
	TEditPaste *StdEditPasteAction;
	TEditSelectAll *StdEditSelectAllAction;
	TEditUndo *StdEditUndoAction;
	TLabel *Label1;
	TListBox *HistListBox;
	TListBox *TextListBox;
	TMemo *ItemMemo;
	TMemo *PreviewMemo;
	TMenuItem *AllDelItem;
	TMenuItem *CopyClipItem;
	TMenuItem *CopyClipItemT;
	TMenuItem *CopyItemE;
	TMenuItem *CutItemE;
	TMenuItem *DelItemItem;
	TMenuItem *DelItemTItem;
	TMenuItem *EditTextDataItem;
	TMenuItem *EditTextItem;
	TMenuItem *ExLineItem;
	TMenuItem *InsFromClipItem;
	TMenuItem *InsSepItem;
	TMenuItem *LoadHistItem;
	TMenuItem *PasteItem;
	TMenuItem *PasteItemE;
	TMenuItem *PasteItemT;
	TMenuItem *PopE_s1;
	TMenuItem *PopT_s1;
	TMenuItem *PopT_s2;
	TMenuItem *PopT_s3;
	TMenuItem *Pop_s1;
	TMenuItem *Pop_s2;
	TMenuItem *Pop_s3;
	TMenuItem *Pop_s4;
	TMenuItem *Pop_s5;
	TMenuItem *Ref_10_item;
	TMenuItem *Ref_11_item;
	TMenuItem *Ref_12_item;
	TMenuItem *Ref_13_item;
	TMenuItem *Ref_14_item;
	TMenuItem *Ref_15_item;
	TMenuItem *Ref_16_item;
	TMenuItem *Ref_17_item;
	TMenuItem *Ref_1_item;
	TMenuItem *Ref_2_item;
	TMenuItem *Ref_3_Item;
	TMenuItem *Ref_4_item;
	TMenuItem *Ref_5_item;
	TMenuItem *Ref_6_item;
	TMenuItem *Ref_7_item;
	TMenuItem *Ref_8_item;
	TMenuItem *Ref_9_item;
	TMenuItem *RegFromClipItem;
	TMenuItem *ReloadTextDataItem;
	TMenuItem *SaveHistItem;
	TMenuItem *SelectAllItemE;
	TMenuItem *SortLcntItem;
	TMenuItem *SortSizeItem;
	TMenuItem *SortTextItem;
	TMenuItem *SortTimeItem;
	TMenuItem *StopHIstItem;
	TMenuItem *UndoItemE;
	TOpenDialog *OpenDialog1;
	TPageControl *PageControl1;
	TPanel *ItemEditPanel;
	TPanel *TextListPanel;
	TPanel *TopPanel;
	TPopupMenu *PopupMenu1;
	TPopupMenu *PopupMenu2;
	TPopupMenu *PopupMenu3;
	TSaveDialog *SaveDialog1;
	TSplitter *Splitter1;
	TStatusBar *StatusBar1;
	TTabSheet *ClipSheet;
	TTabSheet *TextSheet;
	TToolBar *TextDataBar;
	TToolButton *TextDataBtn1;
	TToolButton *TextDataBtn2;
	TToolButton *TextDataBtn3;
	TToolButton *TextDataBtn4;
	TToolButton *TextDataBtn5;
	TToolButton *TextDataBtn6;
	TToolButton *TextDataBtn7;
	TToolButton *TextDataBtn8;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormHide(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall HistListBoxDrawItem(TWinControl *Control, int Index,
		  TRect &Rect, TOwnerDrawState State);
	void __fastcall HistListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall HistListBoxClick(TObject *Sender);
	void __fastcall PasteActionExecute(TObject *Sender);
	void __fastcall SelItemUpdate(TObject *Sender);
	void __fastcall CopyClipActionExecute(TObject *Sender);
	void __fastcall DelItemActionExecute(TObject *Sender);
	void __fastcall AllDelActionExecute(TObject *Sender);
	void __fastcall AllDelActionUpdate(TObject *Sender);
	void __fastcall ExLineActionExecute(TObject *Sender);
	void __fastcall ExLineActionUpdate(TObject *Sender);
	void __fastcall SortTimeActionExecute(TObject *Sender);
	void __fastcall SortTextActionExecute(TObject *Sender);
	void __fastcall SortActionUpdate(TObject *Sender);
	void __fastcall StopActionExecute(TObject *Sender);
	void __fastcall StopActionUpdate(TObject *Sender);
	void __fastcall SaveHistActionExecute(TObject *Sender);
	void __fastcall SaveHistActionUpdate(TObject *Sender);
	void __fastcall LoadHistActionExecute(TObject *Sender);
	void __fastcall ListExtractActionExecute(TObject *Sender);
	void __fastcall ListExtractActionUpdate(TObject *Sender);
	void __fastcall ListExceptActionExecute(TObject *Sender);
	void __fastcall ListExceptActionUpdate(TObject *Sender);
	void __fastcall ListReleaseActionExecute(TObject *Sender);
	void __fastcall ListReleaseActionUpdate(TObject *Sender);
	void __fastcall FindComboBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall FindComboBoxKeyPress(TObject *Sender, System::WideChar &Key);
	void __fastcall TextListBoxClick(TObject *Sender);
	void __fastcall TextListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall TextListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
          TOwnerDrawState State);
	void __fastcall RegFromClipActionExecute(TObject *Sender);
	void __fastcall RegFromClipActionUpdate(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall PageControl1Change(TObject *Sender);
	void __fastcall TextListBoxStartDrag(TObject *Sender, TDragObject *&DragObject);
	void __fastcall TextListBoxDragOver(TObject *Sender, TObject *Source, int X, int Y,
          TDragState State, bool &Accept);
	void __fastcall TextListBoxDragDrop(TObject *Sender, TObject *Source, int X, int Y);
	void __fastcall EditTextDataActionExecute(TObject *Sender);
	void __fastcall EditTextDataActionUpdate(TObject *Sender);
	void __fastcall ReloadTextDataActionExecute(TObject *Sender);
	void __fastcall ReloadTextDataActionUpdate(TObject *Sender);
	void __fastcall RegToTextActionExecute(TObject *Sender);
	void __fastcall RegToTextActionUpdate(TObject *Sender);
	void __fastcall EditOkBtnClick(TObject *Sender);
	void __fastcall EditTextItemActionExecute(TObject *Sender);
	void __fastcall EditTextItemActionUpdate(TObject *Sender);
	void __fastcall EditCanBtnClick(TObject *Sender);
	void __fastcall Ref_ItemClick(TObject *Sender);
	void __fastcall SortLengthActionExecute(TObject *Sender);
	void __fastcall SortLineCntActionExecute(TObject *Sender);
	void __fastcall InsSepItemClick(TObject *Sender);
	void __fastcall DelItemActionUpdate(TObject *Sender);
	void __fastcall TextDataBtnClick(TObject *Sender);
	void __fastcall InsFromClipActionExecute(TObject *Sender);
	void __fastcall InsFromClipActionUpdate(TObject *Sender);


private:	// [U[錾
	HWND  hNextWnd;
	bool  ClipEnabled;		//Ƃ
	bool  ShowLnCt;			//s\
	int   PreviewLn;		//vr[ŏs

	HWND  hLastWnd;
	HWND  hLastFocus;
	DWORD LastThreadID;

	TFont *ClipLstFont;
	TColor colCtrl;
	TColor colLnCt;

	int PrevListIdx;

	TStringList *ExceptWordList;

	void __fastcall WmChangeCbChain(TMessage &msg);
	void __fastcall WmDrawClipboard(TMessage &msg);

	int  __fastcall GetHistListIndex(int idx = -1);
	UnicodeString __fastcall GetListStr(int idx = -1);
	bool __fastcall SaveTextList();
	void __fastcall RegTextList(UnicodeString s, int idx=-1);

public:		// [U[錾
	bool CbChained;				//Nbv{[hE`F[ɂȂĂ
	int  MaxCbItems;			//Nbv{[h̍ő區ڐ
	int  MaxTextLen;			//Nbv{[hɓő啶
	int  MaxLineCnt;			//Nbv{[hɓős
	UnicodeString WmPasteClass;	//WM_PASTE ɂ\tsNX

	THistoryList *ClipHistList;	//Nbv{[h̃Xg
	UnicodeString ClipDataFile;	//Nbv{[h̕ۑt@C
	UnicodeString TextDataFile;	//^̒`t@C
	UnicodeString TextBtnFile[MAX_TEXTDATABTN];

	bool SaveHistory;

	__fastcall TClipBdList(TComponent* Owner);

	void __fastcall RecyclePrc();
	void __fastcall InitClipboardChain();
	void __fastcall UpdateHistList(int idx = 0);
	bool __fastcall AddHistList();
	void __fastcall SaveHistList();
	bool __fastcall ChangeTextData(int idx);

	BEGIN_MESSAGE_MAP
		VCL_MESSAGE_HANDLER(WM_CHANGECBCHAIN,	TMessage, WmChangeCbChain)
		VCL_MESSAGE_HANDLER(WM_DRAWCLIPBOARD,	TMessage, WmDrawClipboard)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TClipBdList *ClipBdList;
//---------------------------------------------------------------------------
#endif
